VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "MakeContent"
   ClientHeight    =   7830
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   11010
   LinkTopic       =   "Form1"
   ScaleHeight     =   7830
   ScaleWidth      =   11010
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtResult 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2415
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   360
      Width           =   3015
   End
   Begin MSComDlg.CommonDialog dlgOpenFile 
      Left            =   4080
      Top             =   840
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DialogTitle     =   "Select File"
      Filter          =   "XML Files (*.xml)|*.xml|All Files (*.*)|*.*"
   End
   Begin MSComDlg.CommonDialog dlgSaveFile 
      Left            =   4080
      Top             =   1440
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DialogTitle     =   "Select File"
      Filter          =   "HTML Files (*.html;*.htm)|*.html;*.htm|All Files (*.*)|*.*"
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileExitSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_FileName As String
Private m_FileTitle As String

' Add the item to the content index files.
Private Sub AddToIndex(ByVal index_url As String, ByVal url As String, ByVal descr As String, ByVal keywords As String, ByVal categories As String, ByRef has_download As Boolean, ByRef has_book As Boolean)
Dim new_item As String
Dim index_file As String
Dim pos1 As Integer
Dim pos2 As Integer

    ' Get index_all.html.
    index_file = LoadFile(BasePath() & "\" & index_url)

    ' Compose the start of the new item's entry.
    new_item = "  <TR><TD><A HREF=""" & url & """>"

    ' See if the new item is already there.
    pos1 = InStr(index_file, new_item)
    If pos1 > 0 Then
        ' Remove the item.
        ' Find the next vbCrLf.
        pos2 = InStr(pos1, index_file, vbCrLf)
        index_file = _
            Left$(index_file, pos1 - 1) & _
            Mid$(index_file, pos2 + 2)
    End If

    ' Compose the new item's complete entry.
    new_item = new_item & _
        descr & "</A></TD>" & _
        "<TD>" & keywords & "</TD>" & _
        "<TD>"
    If has_download Then new_item = new_item & _
        "<IMG ALIGN=""Center"" SRC=""download.gif"" ALT=""Download"">"
    If has_book Then new_item = new_item & _
        "<IMG ALIGN=""Center"" SRC=""book.gif"" ALT=""Download"">"
    If Not (has_download Or has_book) Then new_item = new_item & _
        "&nbsp;"

    ' Insert the new item.
    index_file = Replace(index_file, _
        "<!-- @@@ Add new items here @@@ -->", _
        "<!-- @@@ Add new items here @@@ -->" & vbCrLf & new_item)

    ' Rewrite the index file.
    SaveFile BasePath() & "\index_all.html", index_file
End Sub
' Return the path to the Web site base directory.
Private Function BasePath() As String
Dim result As String
Dim pos As Integer

    ' Go up two directories.
    result = App.Path
    pos = InStrRev(result, "\")
    pos = InStrRev(result, "\", pos - 1)
    BasePath = Left$(result, pos - 1)
End Function

' Convert the code into HTML code.
' - Remove invisible characters from the ends
' - Replace & with &amp;
' - Replace < with &lt;
' - Replace > with &gt;
' - Display comments with color #008000
Private Function CodeToHtml(ByVal code As String) As String
Dim result As String
Dim pos1 As Integer
Dim pos2 As Integer

    code = StripNonPrinting(code)
    code = Replace(code, "&", "&amp;")
    code = Replace(code, "<", "&lt;")
    code = Replace(code, ">", "&gt;")

    ' Color comments.
    Do While Len(code) > 0
        pos1 = InStr(code, "'")
        If pos1 = 0 Then
            ' No more comments.
            result = result & code
            code = ""
        Else
            ' We found a comment. Add the stuff before the
            ' comment and the FONT statement.
            result = result & Left$(code, pos1 - 1) & "<FONT COLOR=""#008000"">"

            ' Find the end of the comment.
            pos2 = InStr(pos1 + 1, code, vbCrLf)
            If pos2 = 0 Then pos2 = Len(code)

            ' Add the comment and the </FONT>.
            result = result & Mid$(code, pos1, pos2 - pos1) & "</FONT>"

            ' Remove the comment from the code.
            code = Mid$(code, pos2)
        End If
    Loop

    ' Return the result.
    CodeToHtml = result
End Function
' Return this file's contents.
Private Function LoadFile(ByVal file_name As String) As String
Dim fnum As Integer

    fnum = FreeFile
    Open file_name For Input As #fnum
    LoadFile = input$(LOF(fnum), #fnum)
    Close #fnum
End Function
' Save this file's contents.
Private Sub SaveFile(ByVal file_name As String, ByVal txt As String)
Dim fnum As Integer

    fnum = FreeFile
    Open file_name For Output As #fnum
    Print #fnum, txt;
    Close #fnum
End Sub

' Return a string representing the file's navigation menus.
Private Function MakeNavigationMenus(ByVal content_document As DOMDocument, ByVal book_asin As String) As String
Dim navigation_menus As String
Dim matching_nodes As IXMLDOMNodeList
Dim dom_node As IXMLDOMNode
Dim menu_num As Integer
Dim rows_left As Integer
Dim last_row As Boolean

    Set matching_nodes = content_document.selectNodes("//Menu")
    rows_left = 1 + (matching_nodes.length - 1) \ 3
    For Each dom_node In matching_nodes
        menu_num = menu_num + 1
        last_row = (rows_left = 1)

        ' See if we need to start a new row.
        If menu_num Mod 3 = 1 Then
            ' Start a new row.
            If last_row Then
                ' Use the lower left corner image.
                navigation_menus = navigation_menus & _
                    "    <TR>" & vbCrLf & _
                    "      <TD ALIGN=""Right"" WIDTH=""20""><IMG SRC=""green_ll.jpg"" WIDTH=""20"" HEIGHT=""20""></TD>" & vbCrLf
            Else
                ' Use the left side image.
                navigation_menus = navigation_menus & _
                    "    <TR>" & vbCrLf & _
                    "      <TD ALIGN=""Right"" WIDTH=""20""><IMG SRC=""green_l.jpg"" WIDTH=""20"" HEIGHT=""20""></TD>" & vbCrLf
            End If
         End If

        ' Build this menu entry.
        If last_row Then
            ' Use the bottom image.
            navigation_menus = navigation_menus & _
                "      <TD WIDTH=""33%"" BACKGROUND=""green_b.jpg"" ALIGN=""Center"">"
        Else
            navigation_menus = navigation_menus & _
                "      <TD WIDTH=""33%"" BGCOLOR=""#7FE398"" ALIGN=""Center"">"
        End If

        If dom_node.Attributes.length > 0 Then
            ' The menu has a URL attribute. Link to it.
            navigation_menus = navigation_menus & "<A HREF=""" & dom_node.Attributes(0).Text & """>"
        Else
            ' The menu has no URL attribute. Bold the item.
            navigation_menus = navigation_menus & "<B>"
        End If

        ' Add the menu text.
        navigation_menus = navigation_menus & dom_node.Text

        ' Close the menu's A or B tag.
        If dom_node.Attributes.length > 0 Then
            navigation_menus = navigation_menus & "</A>"
        Else
            navigation_menus = navigation_menus & "</B>"
        End If

        ' Finish the cell.
        navigation_menus = navigation_menus & "</TD>" & vbCrLf

        ' If this is the last cell in the row, finish the row.
        If menu_num Mod 3 = 0 Then
            If last_row Then
                ' Use the lower right corner image.
                navigation_menus = navigation_menus & _
                    "      <TD ALIGN=""Right"" WIDTH=""20""><IMG SRC=""green_lr.jpg"" WIDTH=""20"" HEIGHT=""20""></TD>" & vbCrLf & _
                    "    </TR>"
            Else
                ' Use the right side image.
                navigation_menus = navigation_menus & _
                    "      <TD WIDTH=""20""><IMG SRC=""green_r.jpg"" WIDTH=""20"" HEIGHT=""20""></TD>" & vbCrLf & _
                    "    </TR>" & vbCrLf
            End If
            rows_left = rows_left - 1
        End If
    Next dom_node

    ' Finish the last row.
    If menu_num Mod 3 <> 0 Then
        ' Add empty menu items.
        Do While menu_num Mod 3 <> 0
            navigation_menus = navigation_menus & _
                "      <TD WIDTH=""33%"" BACKGROUND=""green_b.jpg"" ALIGN=""Center"">&nbsp;</TD>" & vbCrLf
            menu_num = menu_num + 1
        Loop

        ' Add the lower right corner.
        navigation_menus = navigation_menus & _
            "      <TD BGCOLOR=""#E1F3FF"" ALIGN=""Right"" WIDTH=""20""><IMG SRC=""green_lr.jpg"" WIDTH=""20"" HEIGHT=""20""></TD>" & vbCrLf & _
            "    </TR>"
    End If

    ' Replace the ASIN in the Amazon links.
    navigation_menus = Replace(navigation_menus, "@@@ASIN@@@", book_asin)

    MakeNavigationMenus = navigation_menus
End Function
' Return the node's value in the XML document. If the node
' is not present, return the default value.
Private Function GetNodeValue(ByVal content_document As DOMDocument, ByVal node_name As String, Optional ByVal default_value As String = "") As String
Dim dom_node As IXMLDOMNode

    Set dom_node = content_document.selectSingleNode("//" & node_name)
    If dom_node Is Nothing Then
        GetNodeValue = default_value
    Else
        GetNodeValue = dom_node.Text
    End If
End Function

' Replace the indicated targets in the string with the
' corresponding values from the XML document.
Private Function ReplaceTargets(ByVal txt As String, ByVal content_document As DOMDocument, ParamArray targets() As Variant) As String
Dim i As Integer

    For i = LBound(targets) To UBound(targets)
        txt = Replace(txt, "@@@" & targets(i) & "@@@", _
            GetNodeValue(content_document, targets(i)))
    Next i

    ReplaceTargets = txt
End Function

' Convert a page title into a safe URL. For example,
' "Apples & Bananas" converts to "apples_and_bananas".
Private Function TitleToURL(ByVal page_title As String) As String
    page_title = LCase$(page_title)
    page_title = Replace(page_title, " ", "_")
    page_title = Replace(page_title, "&amp;", "and")
    page_title = Replace(page_title, "&gt;", "gt")
    page_title = Replace(page_title, "&lt;", "lt")
    page_title = Replace(page_title, "&", "and")
    page_title = Replace(page_title, ".", "")
    TitleToURL = page_title
End Function
' Process content from XML for use. Replace single vbCr
' and vbLf with vbCrLf, and remove non-printing characters
' from the ends.
Private Function PrepareContent(ByVal txt As String) As String
    txt = Replace(txt, vbCrLf, vbLf)
    txt = Replace(txt, vbCr, vbLf)
    txt = Replace(txt, vbLf, vbCrLf)
    PrepareContent = StripNonPrinting(txt)
End Function

' Process the file.
Private Sub ProcessFile(ByVal file_name As String, ByVal file_title As String)
Dim content_document As DOMDocument
Dim result As String
Dim descr As String
Dim keywords As String
Dim categories As String
Dim has_download As Boolean
Dim has_book As Boolean
Dim pos As Integer
Dim keyword_list As Variant
Dim i As Integer

    ' Load the content document.
    Set content_document = New DOMDocument
    content_document.Load file_name

    ' See what kind of document this is.
    Select Case LCase$(content_document.documentElement.getAttribute("Type"))
        Case "howto"
            result = ProcessHowTo(content_document, descr, keywords, categories, has_download, has_book)
        Case "books"
            result = ProcessBooks(content_document, descr, keywords, categories, has_download, has_book)
        Case "bookdetail"
            result = ProcessBookDetail(content_document, descr, keywords, categories, has_download, has_book)
        Case "genericmenu"
            result = ProcessGenericMenu(content_document, descr, keywords, categories, has_download, has_book)
        Case "contentindex"
            result = ProcessContentIndex(content_document, descr, keywords, categories, has_download, has_book)
    End Select

    ' Display the results.
    result = Trim$(result)
    txtResult.Text = result

    ' Save the results.
    pos = InStrRev(file_title, ".")
    file_title = Left$(file_title, pos) & "html"
    SaveFile BasePath() & "\" & file_title, result

    ' Add the file to the index_all.html.
    AddToIndex "index_all.html", file_title, descr, keywords, categories, has_download, has_book

    ' Add the file to each of the appropriate category indexes.
'@@@
'    keyword_list = Split(keywords, ",")
'    For i = LBound(keyword_list) To UBound(keyword_list)
'    Next i
'    AddToIndex "index_all.html", file_title, descr, keywords, categories, has_download, has_book
'@@@

End Sub
' Process a How To page.
Private Function ProcessHowTo(ByVal content_document As DOMDocument, ByRef descr As String, ByRef keywords As String, ByRef categories As String, ByRef has_download As Boolean, ByRef has_book As Boolean) As String
Const BLANK_LINE = "              <TR><TD>&nbsp;<BR></TD></TR>"
Const CODE_TD = "                <TD BACKGROUND=""computer_paper.jpg"">"
Const CODE_PRESTART = "                  <PRE><FONT NAME=""Courier New"" POINT-SIZE=""10"" SIZE=""2"">"
Const CODE_PREEND = "</FONT></PRE>" & vbCrLf

Dim result As String
Dim download_href As String
Dim dom_node As IXMLDOMNode
Dim child_node As IXMLDOMNode
Dim content_html As String
Dim node_content As String

    ' Load the template file.
    result = LoadFile(BasePath() & "\Templates\template_howto.html")

    ' Get title, keywords, and categories.
    descr = GetNodeValue(content_document, "Title")
    keywords = GetNodeValue(content_document, "Keywords")
    categories = GetNodeValue(content_document, "Categories")

    ' Make easy replacements.
    result = ReplaceTargets(result, content_document, _
        "Title", "Keywords", "Categories", "Purpose")

    ' See if we want a button.
    If CBool(GetNodeValue(content_document, "Button", "False")) Then
        result = Replace(result, "@@@ButtonStart@@@", "")
        result = Replace(result, "@@@ButtonEnd@@@", "")
        download_href = "HowTo/" & Left$(m_FileTitle, InStrRev(m_FileTitle, ".")) & "zip"
        result = Replace(result, "@@@DownloadHREF@@@", download_href)
    Else
        result = Replace(result, "@@@ButtonStart@@@", "<!--")
        result = Replace(result, "@@@ButtonEnd@@@", "-->")
    End If

    ' Process the content.
    Set dom_node = content_document.selectSingleNode("//Content")
    For Each child_node In dom_node.childNodes
        ' See if this is text or code.
        Select Case LCase$(child_node.nodeName)
            Case "codecontent" ' Code.
                node_content = PrepareContent(child_node.Text)
                node_content = CodeToHtml(node_content)
                content_html = content_html & vbCrLf & _
                    "              <!-- Code content -->" & vbCrLf & _
                    BLANK_LINE & vbCrLf & _
                    "              <TR>" & vbCrLf & _
                    CODE_TD & vbCrLf & _
                    CODE_PRESTART & _
                    node_content & _
                    CODE_PREEND & _
                    "              </TD></TR>" & vbCrLf

            Case "textcontent" ' Text.
                node_content = PrepareContent(child_node.Text)
                node_content = Replace(node_content, vbCrLf & vbCrLf, vbCrLf & "<P>" & vbCrLf)
                content_html = content_html & vbCrLf & _
                    "              <!-- Text content -->" & vbCrLf & _
                    BLANK_LINE & vbCrLf & _
                    "              <TR><TD>" & vbCrLf & _
                    node_content & vbCrLf & _
                    "              </TD></TR>" & vbCrLf
            Case Else ' Error.
                Stop
        End Select
    Next child_node
    result = Replace(result, "@@@Content@@@", content_html)

    ' See if the file has a book or download.
    has_book = CBool(GetNodeValue(content_document, "HasBook", "False"))
    has_download = CBool(GetNodeValue(content_document, "HasDownload", "False"))

    ' Return the results.
    ProcessHowTo = result
End Function
' Process a books page.
Private Function ProcessBooks(ByVal content_document As DOMDocument, ByRef descr As String, ByRef keywords As String, ByRef categories As String, ByRef has_download As Boolean, ByRef has_book As Boolean) As String
Const BLANK_LINE = "              <TR><TD>&nbsp;<BR></TD></TR>"

Dim result As String
Dim dom_node As IXMLDOMNode
Dim section_node As IXMLDOMNode
Dim book_node As IXMLDOMNode
Dim content_html As String
Dim book_content As String
Dim matching_nodes As IXMLDOMNodeList
Dim node_keywords As Variant
Dim keyword_list As Collection
Dim keyword As String
Dim i As Integer
Dim picture_column As String
Dim text_column As String
Dim book_link As String
Dim book_asin As String
Dim book_title As String
Dim can_learn_more As Boolean
Dim picture_num As Integer

    ' Load the template file.
    result = LoadFile(BasePath() & "\Templates\template_books.html")

    ' Get title, keywords, and categories.
    descr = GetNodeValue(content_document, "Title")
    keywords = GetNodeValue(content_document, "Keywords")
    categories = GetNodeValue(content_document, "Categories")

    ' Make easy replacements.
    result = ReplaceTargets(result, content_document, _
        "Title", "PageDescription", "Categories", "Header")
    
    ' Make a list of all of the books' Keywords.
    Set matching_nodes = content_document.selectNodes("//Keywords")
    Set keyword_list = New Collection
    On Error Resume Next
    For Each dom_node In matching_nodes
        ' Separate this node's keywords.
        node_keywords = Split(dom_node.Text, ",")

        ' Add the keywords using their values as keys
        ' to prevent duplicates.
        For i = LBound(node_keywords) To UBound(node_keywords)
            keyword = Trim$(node_keywords(i))
            keyword_list.Add keyword, keyword
        Next i
    Next dom_node
    On Error GoTo 0

    ' Make the keywords into a string.
    keywords = ""
    For i = 1 To keyword_list.Count
        keywords = keywords & ", " & keyword_list(i)
    Next i
    If Len(keywords) > 0 Then keywords = Mid$(keywords, 3)

    ' Insert the Keywords.
    result = Replace(result, "@@@Keywords@@@", keywords)

    ' Make the section links.
    Set matching_nodes = content_document.selectNodes("//Section")
    i = 0
    content_html = ""
    For Each section_node In matching_nodes
        If i Mod 3 = 0 Then content_html = content_html & "    <TR>" & vbCrLf
        i = i + 1
        content_html = content_html & "      <TD>" & _
            "<A HREF=""#" & Replace(section_node.Attributes(0).Text, " ", "_") & """>" & _
            section_node.Attributes(0).Text & _
            "</A></TD>" & vbCrLf
        If i Mod 3 = 0 Then content_html = content_html & "    <\TR>" & vbCrLf
    Next section_node
    content_html = content_html & "    <TR>"
    result = Replace(result, "@@@Sections@@@", content_html)

    ' Process the Sections.
    Set matching_nodes = content_document.selectNodes("//Section")
    content_html = ""
    picture_num = 0
    For Each section_node In matching_nodes
        ' Display the section title.
        content_html = content_html & "  <TABLE BGCOLOR=""#7FCFFF"" WIDTH=""100%"">" & vbCrLf & _
            "    <TR><TD ALIGN=""Center""><B>" & section_node.Attributes(0).Text & "</B></TD></TR>" & vbCrLf & _
            "  </TABLE>" & vbCrLf

        ' Display the section's books.
        For Each book_node In section_node.childNodes
            ' Get the book's ASIN.
            Set dom_node = book_node.selectSingleNode("ASIN")
            book_asin = dom_node.Text

            ' Get the book's title.
            Set dom_node = book_node.selectSingleNode("Title")
            book_title = dom_node.Text

            ' Get the link's URL.
            Set dom_node = book_node.selectSingleNode("Link")
            If dom_node Is Nothing Then
                ' There is no link. Use the Amazon link.
                book_link = "http://www.amazon.com/exec/obidos/ASIN/" & _
                    book_asin & "/vbhelper/"
                can_learn_more = False
            Else
                book_link = dom_node.Text
                can_learn_more = True
            End If

            ' Build the picture column.
            Set dom_node = book_node.selectSingleNode("Picture")
            If dom_node Is Nothing Then
                ' There is no picture column.
                picture_column = ""
            Else
                ' Compose the picture column.
                picture_column = _
                    "<TD><A HREF=""" & book_link & """>" & _
                    "<IMG SRC=""" & dom_node.Text & """ " & _
                    "BORDER=""0"" ALT=""" & book_title & """>" & _
                    "</A></TD>"
            End If

            ' Build the text column.
            If Len(picture_column) = 0 Then
                ' There is no picture column.
                ' Make this column span the table.
                text_column = "<TD COLSPAN=""2"">"
            Else
                text_column = "<TD>"
                picture_num = picture_num + 1
            End If
            text_column = text_column & "<B>" & book_title & "</B>, "
            Set dom_node = book_node.selectSingleNode("Price")
            text_column = text_column & dom_node.Text & ", "
            Set dom_node = book_node.selectSingleNode("Pages")
            text_column = text_column & dom_node.Text & " pages, "
            Set dom_node = book_node.selectSingleNode("Paperback")
            If CBool(dom_node.Text) Then
                text_column = text_column & "paperback"
            Else
                text_column = text_column & "hardcover"
            End If
            Set dom_node = book_node.selectSingleNode("CD")
            If CBool(dom_node.Text) Then
                text_column = text_column & " with CD."
            Else
                text_column = text_column & "."
            End If
            Set dom_node = book_node.selectSingleNode("Description")
            text_column = text_column & "<BR>" & _
                dom_node.Text & vbCrLf

            ' Assemble the book's table.
            If picture_num Mod 2 = 0 Then
                ' Put the picture column on the left.
                book_content = _
                    "  <TABLE WIDTH=""100%""><TR>" & vbCrLf & _
                    "    " & picture_column & vbCrLf & _
                    "    " & text_column & vbCrLf & _
                    "  </TABLE>" & vbCrLf
            Else
                ' Put the text column on the left.
                book_content = _
                    "  <TABLE WIDTH=""100%""><TR>" & vbCrLf & _
                    "    " & text_column & vbCrLf & _
                    "    " & picture_column & vbCrLf & _
                    "  </TABLE>" & vbCrLf
            End If

            ' Add the Amazon links.
            book_content = book_content & "<CENTER>["
            If can_learn_more Then
                book_content = book_content & _
                    "<A HREF=""" & book_link & """>Learn more</A> - "
            End If
            book_content = book_content & _
                "<A HREF=""http://www.amazon.com/exec/obidos/ASIN/" & _
                book_asin & "/vbhelper/"">Amazon.com</A> -"
            book_content = book_content & _
                "<A HREF=""http://www.amazon.co.uk/exec/obidos/ASIN/" & _
                book_asin & "/vbhelper0e/"">Amazon.co.uk</A>]</CENTER>"

            ' See if this is not the last book in the section.
            If Not (book_node Is section_node.lastChild) Then
                ' Add a horizontal rule.
                book_content = book_content & "  <HR COLOR=""#7FCFFF"">" & vbCrLf
            End If

            content_html = content_html & book_content
        Next book_node
    Next section_node

    result = Replace(result, "@@@Content@@@", content_html)

    ' See if the file has a book or download.
    has_book = CBool(GetNodeValue(content_document, "HasBook", "False"))
    has_download = CBool(GetNodeValue(content_document, "HasDownload", "False"))

    ' Return the results.
    ProcessBooks = result
End Function
' Process a book detail page.
Private Function ProcessBookDetail(ByVal content_document As DOMDocument, ByRef descr As String, ByRef keywords As String, ByRef categories As String, ByRef has_download As Boolean, ByRef has_book As Boolean) As String
Dim result As String
Dim dom_node As IXMLDOMNode
Dim content_html As String
Dim matching_nodes As IXMLDOMNodeList
Dim navigation_menus As String

    ' Load the template file.
    result = LoadFile(BasePath() & "\Templates\template_book_detail.html")

    ' Get title, keywords, and categories.
    descr = GetNodeValue(content_document, "Title")
    keywords = GetNodeValue(content_document, "Keywords")
    categories = GetNodeValue(content_document, "Categories")

    ' Make easy replacements.
    result = ReplaceTargets(result, content_document, _
        "Title", "Keywords", "Categories", "Picture", _
        "Author", "Price", "Pages", "Copyright", _
        "Publisher", "ISBN")

    ' See if the book is paperback or hardback.
    If CBool(GetNodeValue(content_document, "Paperback", "False")) Then
        content_html = "Paperback"
    Else
        content_html = "Hardback"
    End If

    ' See if the book has a CD.
    If CBool(GetNodeValue(content_document, "CD", "False")) Then
        content_html = content_html & " with CD"
    End If
    result = Replace(result, "@@@Paperback@@@", content_html)

    ' Display the Introduction.
    Set dom_node = content_document.selectSingleNode("//Introduction")

    ' See if the introduction has a title.
    If dom_node.Attributes.length = 0 Then
        ' There's no title.
        content_html = ""
    Else
        ' There's a title.
        content_html = "<CENTER><B>" & _
            dom_node.Attributes(0).Text & "</B></CENTER>" & vbCrLf & _
            "        <P>" & vbCrLf & _
            "        "
    End If

    ' Add the introduction text.
    content_html = content_html & PrepareContent(dom_node.Text)
    result = Replace(result, "@@@Introduction@@@", content_html)

    ' Compose the main body of content.
    content_html = ""
    Set matching_nodes = content_document.selectNodes("//Content")
    For Each dom_node In matching_nodes
        ' See if there is a title.
        If dom_node.Attributes.length > 0 Then
            ' Display the title.
            content_html = content_html & vbCrLf & _
                "  <TABLE WIDTH=""100%"" CELLPADDING=""0"" CELLSPACING=""0"">" & vbCrLf & _
                "    <TR><TD BGCOLOR=""#7FCFFF"" ALIGN=""Center""><B>" & _
                dom_node.Attributes(0).Text & "</B></TD></TR>" & vbCrLf & _
                "  </TABLE>" & vbCrLf & "  <P>" & vbCrLf
        End If

        ' Add the content.
        content_html = content_html & vbCrLf & _
            "  " & PrepareContent(dom_node.Text) & vbCrLf & "  <P>" & vbCrLf
    Next dom_node
    result = Replace(result, "@@@Content@@@", content_html)

    ' Display the navigation menus.
    navigation_menus = MakeNavigationMenus( _
        content_document, Replace( _
            GetNodeValue(content_document, "ISBN"), "-", ""))
    result = Replace(result, "@@@NavigationMenus@@@", navigation_menus)

    ' See if the file has a book or download.
    has_book = CBool(GetNodeValue(content_document, "HasBook", "False"))
    has_download = CBool(GetNodeValue(content_document, "HasDownload", "False"))

    ' Return the results.
    ProcessBookDetail = result
End Function
' Process a generic page with navigation menus.
Private Function ProcessGenericMenu(ByVal content_document As DOMDocument, ByRef descr As String, ByRef keywords As String, ByRef categories As String, ByRef has_download As Boolean, ByRef has_book As Boolean) As String
Dim result As String
Dim dom_node As IXMLDOMNode
Dim content_html As String
Dim matching_nodes As IXMLDOMNodeList
Dim navigation_menus As String

    ' Load the template file.
    result = LoadFile(BasePath() & "\Templates\template_generic_menu.html")

    ' Get title, keywords, and categories.
    descr = GetNodeValue(content_document, "Title")
    keywords = GetNodeValue(content_document, "Keywords")
    categories = GetNodeValue(content_document, "Categories")

    ' Make easy replacements.
    result = ReplaceTargets(result, content_document, _
        "Title", "Keywords", "Categories")

    ' Compose the main body of content.
    content_html = ""
    Set matching_nodes = content_document.selectNodes("//Content")
    For Each dom_node In matching_nodes
        ' See if there is a title.
        If dom_node.Attributes.length > 0 Then
            ' Display the title.
            content_html = content_html & vbCrLf & _
                "  <TABLE WIDTH=""100%"" CELLPADDING=""0"" CELLSPACING=""0"">" & vbCrLf & _
                "    <TR><TD BGCOLOR=""#7FCFFF"" ALIGN=""Center""><B>" & _
                dom_node.Attributes(0).Text & "</B></TD></TR>" & vbCrLf & _
                "  </TABLE>" & vbCrLf & "  <P>" & vbCrLf
        End If

        ' Add the content.
        content_html = content_html & vbCrLf & _
            "  " & PrepareContent(dom_node.Text) & vbCrLf & "  <P>" & vbCrLf
    Next dom_node
    result = Replace(result, "@@@Content@@@", content_html)

    ' Display the navigation menus.
    navigation_menus = MakeNavigationMenus( _
        content_document, Replace( _
            GetNodeValue(content_document, "ISBN"), "-", ""))
    result = Replace(result, "@@@NavigationMenus@@@", navigation_menus)

    ' See if the file has a book or download.
    has_book = CBool(GetNodeValue(content_document, "HasBook", "False"))
    has_download = CBool(GetNodeValue(content_document, "HasDownload", "False"))

    ' Return the results.
    ProcessGenericMenu = result
End Function
' Process an index page.
Private Function ProcessContentIndex(ByVal content_document As DOMDocument, ByRef descr As String, ByRef keywords As String, ByRef categories As String, ByRef has_download As Boolean, ByRef has_book As Boolean) As String
Dim result As String
Dim dom_node As IXMLDOMNode
Dim category_node As IXMLDOMNode
Dim subcategory_node As IXMLDOMNode
Dim content_html As String
Dim matching_nodes As IXMLDOMNodeList
Dim menu_num As Integer

    ' Load the template file.
    result = LoadFile(BasePath() & "\Templates\template_index_categories.html")

    ' Get title, keywords, and categories.
    descr = GetNodeValue(content_document, "Title")
    keywords = GetNodeValue(content_document, "Keywords")
    categories = GetNodeValue(content_document, "Categories")

    ' Make easy replacements.
    result = ReplaceTargets(result, content_document, _
        "Title", "Keywords", "Categories")

    ' Compose the main body of content.
    content_html = ""
    Set matching_nodes = content_document.selectNodes("//Category")
    menu_num = 0
    For Each category_node In matching_nodes
        ' See if we need to start a new row.
        menu_num = menu_num + 1
        If menu_num Mod 2 = 1 Then content_html = content_html & "  <TR>" & vbCrLf

        ' Add the category name.
        content_html = content_html & _
            "    <TD ALIGN=""Center"" WIDTH=""50%"">" & vbCrLf & _
            "      <FONT SIZE=""+1""><A HREF=""index_" & _
            TitleToURL(category_node.Attributes(0).Text) & ".html""><B>" & _
            category_node.Attributes(0).Text & _
            "</B></A></FONT><BR>" & vbCrLf

        ' Add the subcategories.
        For Each subcategory_node In category_node.childNodes
            content_html = content_html & _
                "      <A HREF=""index_" & _
                TitleToURL(subcategory_node.Text) & _
                ".html"">" & _
                subcategory_node.Text & _
                "</A>&nbsp;" & vbCrLf
        Next subcategory_node

        ' End the cell.
        content_html = content_html & "    </TD>" & vbCrLf

        ' See if we need to end the row.
        If menu_num Mod 2 = 0 Then content_html = content_html & "  </TR>" & vbCrLf
    Next category_node

    ' If there are an odd number of entries, end the last row.
    If menu_num Mod 2 = 1 Then content_html = content_html & "  </TR>" & vbCrLf

    result = Replace(result, "@@@IndexEntries@@@", content_html)

    ' See if the file has a book or download.
    has_book = CBool(GetNodeValue(content_document, "HasBook", "False"))
    has_download = CBool(GetNodeValue(content_document, "HasDownload", "False"))

    ' Return the results.
    ProcessContentIndex = result
End Function
' Remove non-printing characters from the front and back
' of the string.
Private Function StripNonPrinting(ByVal txt As String) As String
Dim ch As String
Dim pos1 As Integer
Dim pos2 As Integer

    ' Find the first visible character.
    For pos1 = 1 To Len(txt)
        ch = Mid$(txt, pos1, 1)
        If ch >= " " And ch <= "~" Then Exit For
    Next pos1

    ' See if the whole things is invisible.
    If pos1 > Len(txt) Then Exit Function

    ' Find the last visible character.
    For pos2 = Len(txt) To 1 Step -1
        ch = Mid$(txt, pos2, 1)
        If ch >= " " And ch <= "~" Then Exit For
    Next pos2

    ' Return what's between pos1 and pos2 inclusive.
    StripNonPrinting = Mid$(txt, pos1, pos2 - pos1 + 1)
End Function
Private Sub Form_Load()
    dlgOpenFile.Flags = _
        cdlOFNFileMustExist Or _
        cdlOFNHideReadOnly Or _
        cdlOFNLongNames
    dlgOpenFile.InitDir = BasePath() & "\Content"

    dlgSaveFile.Flags = _
        cdlOFNOverwritePrompt Or _
        cdlOFNHideReadOnly Or _
        cdlOFNLongNames
    dlgSaveFile.InitDir = BasePath()
End Sub


Private Sub Form_Resize()
    txtResult.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub mnuFileOpen_Click()
    ' Load the file.
    On Error Resume Next
    dlgOpenFile.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error " & Err.Number & " selecting file" & _
            vbCrLf & Err.Description
        Exit Sub
    End If

    ' Process the file.
    On Error GoTo 0
    m_FileName = dlgOpenFile.FileName
    m_FileTitle = dlgOpenFile.FileTitle
    Caption = "MakeContent [" & m_FileTitle & "]"
    ProcessFile m_FileName, m_FileTitle
End Sub
